> For the complete documentation index, see [llms.txt](https://developers.make.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.make.com/custom-apps-documentation/get-started/make-apps-editor/apps-sdk/local-development-for-apps/create-a-new-app-origin.md).

# Create a new app origin

An app origin connects the local app with an app in Make. The origins are stored in the `origins` array of the **makecomapp.json** file.

One local app can have multiple origins. This is useful when you manage multiple versions of an app, for example, a [testing and a production app](/custom-apps-documentation/get-started/make-apps-editor/apps-sdk/manage-testing-and-production-app-versions.md), or a testing app for each developer when you [develop apps collaboratively](/custom-apps-documentation/get-started/make-apps-editor/apps-sdk/develop-apps-collaboratively.md).

Before you create a new app origin, make sure that the app exists in Make. If you want to deploy the local app to a new app, create an empty app in Make first.

## Create an origin in the deployment dialog

{% stepper %}
{% step %}
Right-click the **makecomapp.json** file and select **Deploy to Make**.
{% endstep %}

{% step %}
In the dialog, select **> Deploy into another app**.

The extension adds a new origin to the **makecomapp.json** file and opens the file.
{% endstep %}

{% step %}
Replace all `-FILL-ME-` values in the new origin. For the description of the values, see [Origin properties](#origin-properties).
{% endstep %}

{% step %}
Save the changes in the **makecomapp.json** file.
{% endstep %}
{% endstepper %}

You have created a new app origin. When you deploy, pull, or compare changes, you can select the new origin in the dialog.

If the API key file of the origin doesn't exist yet, the extension asks you for the API key. You can use the API key from one of your environments in the extension or enter a different one. The extension tests the API key and saves it to the file.

{% hint style="info" %}
If you have selected an origin with the **+ set as default until VS Code restart** option, the dialog doesn't appear until you restart VS Code.
{% endhint %}

## Create an origin manually

Go to the **makecomapp.json** file in the local app repository. Locate the `origins` array and enter a new item by copying the code below and editing the values as described in [Origin properties](#origin-properties).

```json
"origins": [
    { /* --- Existing origin --- */ },
    {
        "label": "Testing",
        "baseUrl": "https://eu1.make.com/api",
        "appId": "my-first-app-test",
        "appVersion": 1,
        "apikeyFile": "../.secrets/apikey"
    }
]
```

Save the changes in the **makecomapp.json** file.

## Origin properties

| Property     | Description                                                                                                                                                                             |
| ------------ | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `label`      | The label of the origin that is displayed when you select an origin, for example, `Testing`.                                                                                            |
| `baseUrl`    | The API URL of the Make zone where the app is, for example, `https://eu1.make.com/api`.                                                                                                 |
| `appId`      | The ID of the app in Make.                                                                                                                                                              |
| `appVersion` | The major version of the app. In most cases, the version is `1`.                                                                                                                        |
| `apikeyFile` | The path to the file with the API key, relative to the **makecomapp.json** file. The API key must have access to the app. Origins with the same `apikeyFile` path use the same API key. |

The extension also adds the `idMapping` property to the origin. The `idMapping` pairs the local components with the components of the app in Make. Don't edit it manually.

{% hint style="warning" %}
If the local app is shared among multiple developers, the `origins` array contains records for each connection between their local and Make (remote) app. Do not edit the current records to prevent breaking the connections.

Use your own `apikeyFile` path, different from the paths of the other developers' origins.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developers.make.com/custom-apps-documentation/get-started/make-apps-editor/apps-sdk/local-development-for-apps/create-a-new-app-origin.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
